<#ibiztemplate>
TARGET=PSSYSTEM
</#ibiztemplate>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <artifactId>${pub.getCodeName()?lower_case}-srv</artifactId>
    <name>${pub.getCodeName()?lower_case}-srv</name>
    <packaging>jar</packaging>
    <parent>
        <artifactId>${sys.codeName}</artifactId>
        <groupId>${pub.getPKGCodeName()}</groupId>
        <version>0.0.1-SNAPSHOT</version>
        <relativePath>../pom.xml</relativePath>
    </parent>
    <#assign mspkg = pub.getPKGCodeName()>
	<#assign msmain = pub.codeName+"Main">
    <dependencies>
    </dependencies>
    <build>
        <resources>
            <resource>
                <directory>${r'${basedir}'}/src/main/webapp</directory>
                <targetPath>META-INF/resources</targetPath>
                <includes>
                    <include>**/**</include>
                </includes>
            </resource>
            <resource>
                <directory>${r'${basedir}'}/src/main/resources</directory>
                <includes>
                    <include>**/**</include>
                </includes>
            </resource>
            <resource>
                <directory>src/main/docker</directory>
                <filtering>true</filtering>
                <includes>
                    <include>**/Dockerfile</include>
                </includes>
                <targetPath>../docker</targetPath>
            </resource>
        </resources>
        <plugins>
            <plugin>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-maven-plugin</artifactId>
                <configuration>
                    <finalName>${sys.codeName?lower_case}</finalName>
                    <jvmArguments>-Dfile.encoding=UTF-8</jvmArguments>
					<#if msmain??>
					<mainClass>${mspkg?lower_case}.boot.${pub.getCodeName()?lower_case}Main</mainClass>
                    </#if>
                    <outputDirectory>../</outputDirectory>
                </configuration>
                <executions>
                    <execution>
                        <goals>
                            <goal>repackage</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>com.spotify</groupId>
                <artifactId>docker-maven-plugin</artifactId>
                <version>1.2.0</version>
                <configuration>
                    <dockerDirectory>target/docker</dockerDirectory>
                    <registryUrl>registry.ibiz5.com:5000</registryUrl>
                    <imageName>
                        registry.ibiz5.com:5000/sadept2/${sys.codeName?lower_case}:latest
                    </imageName>
                    <imageTags>
                        <imageTag>latest</imageTag>
                    </imageTags>
                    <resources>
                        <rescource>
                            <targetPath>/</targetPath>
                            <directory>../</directory>
                            <include>${sys.codeName?lower_case}.jar</include>
                        </rescource>
                    </resources>
                </configuration>
            </plugin>
        </plugins>
    </build>
    <#if sys.getAllPSApps()??>
    <profiles>
        <profile>
            <id>prod</id>
            <build>
                <plugins>
                    <plugin>
                        <groupId>org.codehaus.mojo</groupId>
                        <artifactId>exec-maven-plugin</artifactId>
                        <version>1.6.0</version>
                        <executions>
                            <execution>
                                <id>exec-yarn-run-install</id>
                                <phase>prepare-package</phase>
                                <goals>
                                    <goal>exec</goal>
                                </goals>
                                <configuration>
                                    <executable>yarn</executable>
                                    <workingDirectory>../app_${pub.getPSApplication().getPKGCodeName()}</workingDirectory>
                                </configuration>
                            </execution>
                            <execution>
                                <id>exec-yarn-run-build</id>
                                <phase>prepare-package</phase>
                                <goals>
                                    <goal>exec</goal>
                                </goals>
                                <configuration>
                                    <executable>yarn</executable>
                                    <arguments>
                                        <argument>build</argument>
                                    </arguments>
                                    <workingDirectory>../app_${pub.getPSApplication().getPKGCodeName()}</workingDirectory>
                                </configuration>
                            </execution>
                        </executions>
                    </plugin>
                </plugins>
            </build>
        </profile>
    </profiles>
    </#if>
</project>
