<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
package ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.mapper.${item.codeName}Mapper;
import ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.domain.${item.codeName};
import ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.service.${item.codeName}Service;
import ${pub.getPKGCodeName()}.ibizutil.service.ServiceImplBase;
import ${pub.getPKGCodeName()}.${item.getPSSystemModule().codeName?lower_case}.service.dto.${item.codeName}SearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import ${pub.getPKGCodeName()}.ibizutil.annotation.PreField;
import java.lang.reflect.Field;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;

<#comment>引入关系实体service包</#comment>
<#if item.getMinorPSDERs?? && item.getMinorPSDERs()??>
    <#list item.getMinorPSDERs() as MinorPSDER>
        <#if MinorPSDER??>
            <#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()?? && MinorPSDER.getCodeName?? && MinorPSDER.getCodeName()?? && MinorPSDER.getDERType()=='DER1N'>
                <#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
                <#if MajorEntity.getCodeName?? && MinorPSDER.getCodeName()?? >
import ${pub.getPKGCodeName()}.${MajorEntity.getPSSystemModule().getCodeName()?lower_case}.service.${MajorEntity.getCodeName()}Service;
                </#if>
            </#if>
        </#if>
    </#list>
</#if>

/**
 * 实体[${item.codeName}] 服务对象接口实现
 */
@Service
public class ${item.codeName}ServiceImpl extends ServiceImplBase<${item.codeName}Mapper, ${item.codeName}> implements ${item.codeName}Service{

<#comment>创建1：N关系实体-输出主实体</#comment>
<#if item.getMinorPSDERs?? && item.getMinorPSDERs()??>
    <#list item.getMinorPSDERs() as MinorPSDER>
        <#if MinorPSDER?? && MinorPSDER.getDERType()=='DER1N'>
            <#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()?? && MinorPSDER.getCodeName?? && MinorPSDER.getCodeName()??>
                <#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
                <#if MajorEntity.getCodeName?? && MinorPSDER.getCodeName()?? >
    @Autowired
    private ${MajorEntity.getCodeName()}Service ${MinorPSDER.getCodeName()?lower_case}Service;
                </#if>
            </#if>
        </#if>
    </#list>
</#if>
    @Resource
    private ${item.codeName}Mapper ${item.codeName?lower_case}Mapper;

	<#if item.getKeyPSDEField()??>
        <#assign keyfield=item.getKeyPSDEField()>
		<#assign keyfieldName=item.getKeyPSDEField().codeName>
    @Override
    public boolean create(${item.codeName} et) {
        this.beforeCreate(et);
        <#if item.getUnionKeyValuePSDEFields()?? && item.getKeyPSDEField()??><#comment>判断是否为联合主键模式</#comment>
        ${srfjavatype(keyfield.stdDataType)} primaryKey=et.get${keyfieldName?lower_case?cap_first}();
        if(StringUtils.isEmpty(primaryKey))
        {
            primaryKey=(${srfjavatype(keyfield.stdDataType)})et.getDefaultPrimaryKey();
            et.set${keyfieldName?lower_case?cap_first}(primaryKey);
         }
        </#if>
         return super.create(et);
    }
    </#if>
    <#comment>判断是否为联合主键模式</#comment>
    <#if item.getUnionKeyValuePSDEFields()?? && item.getKeyPSDEField()??>
        <#assign keyfield=item.getKeyPSDEField()>
        <#assign keyfieldName=item.getKeyPSDEField().codeName>
    @Override
	public ${item.codeName} get(${item.codeName} et) {
        ${srfjavatype(keyfield.stdDataType)} primaryKey=et.get${keyfieldName?lower_case?cap_first}();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(${srfjavatype(keyfield.stdDataType)})et.getDefaultPrimaryKey();
             et.set${keyfieldName?lower_case?cap_first}(primaryKey);
          }
		      return super.get(et);
	}
    @Override
   	public boolean remove(${item.codeName} et) {
        ${srfjavatype(keyfield.stdDataType)} primaryKey=et.get${keyfieldName?lower_case?cap_first}();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(${srfjavatype(keyfield.stdDataType)})et.getDefaultPrimaryKey();
             et.set${keyfieldName?lower_case?cap_first}(primaryKey);
          }
   		     return super.remove(et);
   	}
    @Override
    public boolean update(${item.codeName} et){
        ${srfjavatype(keyfield.stdDataType)} primaryKey=et.get${keyfieldName?lower_case?cap_first}();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(${srfjavatype(keyfield.stdDataType)})et.getDefaultPrimaryKey();
             et.set${keyfieldName?lower_case?cap_first}(primaryKey);
         }
		     this.${item.codeName?lower_case}Mapper.updateById(et);
		     this.get(et);
             return true;
    }
    <#else>
    @Override
    public boolean update(${item.codeName} et){
        this.beforeUpdate(et);
		this.${item.codeName?lower_case}Mapper.updateById(et);
		this.get(et);
		return true;
    }
    </#if>
    public Object getEntityKey(${item.codeName} et){
		return et.get<#list item.getPSDEFields() as defield><#if !item.isVirtual() ><#if defield.isKeyDEField()>${defield.codeName?lower_case?cap_first}</#if></#if></#list>();  
    }
<#comment>加载草稿-用于填充外键值</#comment>
    @Override
    public boolean getDraft(${item.codeName} et)  {
<#if item.getMinorPSDERs?? && item.getMinorPSDERs()??>
    <#list item.getMinorPSDERs() as MinorPSDER>
        <#if MinorPSDER??>
            <#if MinorPSDER.getMajorPSDataEntity?? && MinorPSDER.getMajorPSDataEntity()?? && MinorPSDER.getCodeName?? && MinorPSDER.getCodeName()?? && MinorPSDER.getDERType()=='DER1N'>
                <#assign MajorEntity = MinorPSDER.getMajorPSDataEntity()>
                <#if MajorEntity.getCodeName?? && MinorPSDER.getCodeName()?? >
    if((!StringUtils.isEmpty(et.get${MinorPSDER.getPSPickupDEField().getCodeName()?lower_case?cap_first}())) && et.get${MinorPSDER.getCodeName()?lower_case?cap_first}() == null){
            try {
                et.set${MinorPSDER.getCodeName()?lower_case?cap_first}(${MinorPSDER.getCodeName()?lower_case}Service.getById(et.get${MinorPSDER.getPSPickupDEField().getCodeName()?lower_case?cap_first}()));
            }catch (Exception ex){}
        }
                </#if>
            </#if>
        </#if>
    </#list>
            return true;
    }
</#if>
<#comment>发布用户自定义行为</#comment>
<#if item.getAllPSDEActions()??>
    <#list item.getAllPSDEActions() as deaction>
        <#if deaction.getActionType ?? && deaction.getActionType()?? >
            <#if deaction.getActionType() !='BUILTIN'>
                <#if deaction.getPSDELogic?? && deaction.getPSDELogic()??><#comment>判断是否引用实体处理逻辑</#comment>
                    <#assign delogic=deaction.getPSDELogic()>
                    <#assign logicRefDataEntity=delogic.getPSDataEntity()>
                    <#if !P.exists(logicRefDataEntity.codeName?lower_case,"_Logic_")>
    @Autowired
    ${pub.getPKGCodeName()}.${logicRefDataEntity.getPSSystemModule().codeName?lower_case}.logic.${logicRefDataEntity.codeName}Logic ${logicRefDataEntity.codeName?lower_case}Logic;
                    </#if>
                </#if>
    @Override
    public ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${item.codeName} et)  {
        <#if deaction.getPSDELogic?? && deaction.getPSDELogic()??><#comment>判断是否引用实体处理逻辑</#comment>
        <#assign delogic=deaction.getPSDELogic()>
        ${logicRefDataEntity.codeName?lower_case}Logic.${srfmethodname(delogic.getCodeName())}(et);
        </#if>
		return et;
    }
            </#if>
        </#if>
    </#list>
</#if>
<#if item.getAllPSDEDataSets()??>
<#list item.getAllPSDEDataSets() as dedataset>
	public List<${item.codeName}> list${dedataset.getCodeName()}(${item.codeName}SearchFilter filter) {
		return ${item.codeName?lower_case}Mapper.search${dedataset.getCodeName()}(filter,filter.getSelectCond());
	}
	public Page<${item.codeName}> search${dedataset.getCodeName()}(${item.codeName}SearchFilter filter) {
		return ${item.codeName?lower_case}Mapper.search${dedataset.getCodeName()}(filter.getPage(),filter,filter.getSelectCond());
	}
</#list>
    public  List<Map<String,Object>> selectRow(String sql){
       return ${item.codeName?lower_case}Mapper.selectRow(sql);
    }
</#if>
<#comment>实体主状态-重定向视图</#comment>
<#if item.getAllPSDEMainStates?? && item.getAllPSDEMainStates()??>
<#if item.getDEMainStateDEFields?? && item.getDEMainStateDEFields()??>
    /**
     * 获取实体主状态
     * @param et 业务数据
     * @return
     */
    public String getMajState(${item.codeName} et)
    {
        String strMajState="";
        TreeMap<String,String> matchMap = new TreeMap<>();
        //输出实体主状态
        <#list item.getAllPSDEMainStates() as DEState>
         if(isMatchCond("${DEState.getMSTag()?lower_case}",et))
             matchMap.put(getWildcardCnt("${DEState.getMSTag()?lower_case}"),"${DEState.getMSTag()?lower_case}");
        </#list>
        if(matchMap.size()>0){
            strMajState=matchMap.get(matchMap.firstKey());
        }
        return strMajState;
    }
    /**
     * 判断是否满足实体主状态
     * @param strMSTag
     * @param et
     * @return
     */
    public boolean isMatchCond(String strMSTag ,${item.codeName} et)
    {
        boolean flag=false;
        //list遍历出主状态属性
        <#assign stateFieldSize=0 />
        <#list item.getDEMainStateDEFields() as stateField>
        String dataState${stateFieldSize}=et.get${stateField.codeName?lower_case?cap_first}();
        <#assign stateFieldSize=stateFieldSize+1/>
        </#list>
        if(!StringUtils.isEmpty(strMSTag)){
           String deState[]=strMSTag.split("__");
        <#if stateFieldSize==1>
            if(deState.length==1){
                if(dataState0.equals(deState[0]) || (deState[0].equals("*") ) ){
                    flag=true;
                }
            }
        <#elseif stateFieldSize==2>
             if(deState.length==2){
                if(
                    dataState0.equals(deState[0])&& dataState1.equals(deState[1]) ||
                    (dataState0.equals(deState[0])&&  deState[1].equals("*") )  ||
                    (dataState1.equals(deState[1])&&  deState[0].equals("*") )  ||
                    (deState[0].equals("*") && deState[1].equals("*"))
                ){
                    flag=true;
                }
            }
        <#elseif stateFieldSize==3>
            if(deState.length==3){
                if(
                    dataState0.equals(deState[0])&& dataState1.equals(deState[1])&& dataState2.equals(deState[2]) ||
                    ( dataState0.equals(deState[0]) &&    deState[1].equals("*")   && deState[2].equals("*")     ) ||
                    ( dataState1.equals(deState[1]) &&    deState[0].equals("*")   && deState[2].equals("*")     ) ||
                    ( dataState2.equals(deState[2]) &&    deState[0].equals("*")   && deState[1].equals("*")     ) ||
                    ( dataState0.equals(deState[0]) &&    dataState1.equals(deState[1])   && deState[2].equals("*") ) ||
                    ( dataState1.equals(deState[1]) &&    dataState2.equals(deState[2])   && deState[0].equals("*") ) ||
                    ( dataState0.equals(deState[0]) &&    dataState2.equals(deState[2])   && deState[1].equals("*") ) ||
                    (  deState[0].equals("*") &&   deState[1].equals("*")  && deState[2].equals("*") )
                )
                {
                    flag=true;
                }
            }
        <#else>
        //[目前仅支持三个参数内的主状态值]
        </#if>
        }
         return flag;
    }
     /**
     * 通配符数量
     * @param strMSTag
     * @return
     */
    public String getWildcardCnt(String strMSTag){
        Pattern p = Pattern.compile("\\*");
        Matcher m = p.matcher(strMSTag);
        int i = 0;
        while(m.find()){
            i++;
        }
        return String.valueOf(i);
    }
</#if>
</#if>
<#comment>发布临时模式行为</#comment>
<#if item.isEnableTempData()==true>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if deaction.getActionType ?? && deaction.getActionType()?? >
                <#if deaction.getActionType() =='BUILTIN' && deaction.codeName?lower_case?contains("temp")><#comment>临时数据模式行为</#comment>
                    <#assign dataType="boolean">
                    <#if deaction.getCodeName() == "GetTemp">
                        <#assign dataType=item.codeName>
                    </#if>
    @com.baomidou.dynamic.datasource.annotation.DS("tempMaster")
    @Override
    public ${dataType} ${srfmethodname(deaction.getCodeName())}(${item.codeName} et)  {
        return super.${srfmethodname(deaction.getCodeName())}(et);
    }
                </#if>
            </#if>
        </#list>
    </#if>
</#if>
    @Override
    public Page<${item.codeName}> selectPermission(QueryWrapper<${item.codeName}> selectCond) {
        return ${item.codeName?lower_case}Mapper.selectPermission(new ${item.codeName}SearchFilter().getPage(),selectCond);
    }
 }